﻿package
{
	import flash.display.Sprite;
	import flash.events.Event;
	import flash.events.MouseEvent;
	import src.MyCamera;
	import flash.filters.BlurFilter;
	import flash.display.BitmapData;
	import flash.display.Bitmap;
	import flash.geom.Point;
	import flash.geom.Matrix;
	
	
	public class Griffer extends Sprite
	{
		public static var rot:Number = 0;
		public static var activenodes:Number = 0;
		private var theta:Number=0;//rotation des particules
		private var myCam:MyCamera;
		private var recorder:BitmapData;
		private var bmpData:BitmapData;
		private var container:Sprite = new Sprite;
		private var filterObj:BlurFilter = new BlurFilter(4,4,1);//permet de faire disparaître particules
		private var ex_mouse:Object = {x:0,y:0};
		public function Griffer()
		{
			addEventListener(Event.ADDED_TO_STAGE,addedHandler);	
		}
		private function addedHandler(e:Event):void
		{
			myCam = new MyCamera ("computer","",stage.stageWidth,stage.stageHeight,true);
			recorder = new BitmapData (myCam.width,myCam.height, true, 0);
			bmpData = new BitmapData(stage.stageWidth,stage.stageHeight,true,0);
			//addChild(new Bitmap(recorder)) as Bitmap;//wanna see the camera?
			addChild(new Bitmap(bmpData)) as Bitmap;
			
			addEventListener(Event.ENTER_FRAME,enterHandler);
		}
		private function draw_snakes(color:uint):void
		{
			var b:Bloc = new Bloc(0,color);
			b.x = mouseX;
			b.y = mouseY;
			b.scaleX = b.scaleY = (5 + Math.random()*20)/100;
			container.addChild(b);
			
			//if(mouseY>stage.stageHeight/2){b.scaleY*=-1;}
			activenodes++;
			
			if (container.numChildren > 50) container.removeChildAt(0);
		}
		private function enterHandler(e:Event):void
		{
			calc_angle ();
			recorder.draw(myCam);
			draw_snakes(recorder.getPixel32(mouseX,mouseY));
			bmpData.draw(container,new Matrix(1,0,0,1,0,0));
			bmpData.applyFilter(bmpData,bmpData.rect,new Point(0,0),filterObj);
		}
		private function calc_angle (){
			var distanceX	: Number = mouseX - ex_mouse.x;
			var distanceY	: Number = mouseY - ex_mouse.y;
			var hyp			: Number = Math.sqrt( distanceX*distanceX + distanceY*distanceY );
			var angleInRadians : Number = Math.atan2(distanceY, distanceX);
			var andleInDegrees : Number = angleInRadians * (180 / Math.PI);
			
			rot = -andleInDegrees*hyp*0.003;
			//hyp permettant de controler la vitesse de rotation
			//plus la souris va vite, plus la rotation
			
			ex_mouse.x = mouseX;	ex_mouse.y = mouseY;
		}
	}
}
import flash.display.Sprite;
import flash.utils.clearInterval;
import flash.utils.setInterval;
import Griffer;
internal class Bloc extends Sprite{
	private var id:uint;
	private var _depth:Number;
	private var _color:uint;
	public function Bloc(depth:Number,color:uint)
	{
		_color = color
		_depth = depth;
		this.graphics.beginFill(_color,1);
		this.graphics.drawRect(-50,-10,100,20);
		this.graphics.endFill();
		if(_depth<70){id = setInterval(branche,10);}else{Griffer.activenodes--;}
	}
	private function branche():void
	{
		clearInterval(id);
		_depth++;
		var b:Bloc = new Bloc(_depth,_color);
		b.y = -80;
		//b.scaleX = b.scaleY = b.alpha = 0.98;
		b.rotation = Griffer.rot;
		addChild(b);
	}
}